/*
 *	GIF coded CII
 *		August 1994, by Akira KITAUCHI
 *
 *              E-mail address: kitauchi@i.h.kyoto-u.ac.jp
 *              WWW home page : http://www.i.h.kyoto-u.ac.jp/~kitauchi/
 */

#include <memory.h>

#define fgColor	(isAnchor ? lkColor : txColor)

#if defined PLUS256C
extern int xbm256w, xbm256h;
#else
static int xbm256w, xbm256h;
#endif

extern int xbmJISw, xbmJISh;

static int isH2, isH3, isH4, isH5, isH6;
static int txColor = 0x000000;
static int lkColor = 0x0000ee;

/*----
 *	text to CII/GIF converter
 */
static void GIFCII_init (isMozilla)
    int isMozilla;
{
	if (!*Hchar)
	  Hchar = "k";
	if (!isMozilla)
	  lkColor = 0x0000b0;
}

static GIFCII_setfsize (chHp, chWp, Acharp, do256)
	int *chHp, *chWp, do256;
	char **Acharp;
{
  if (do256) {
    *chHp = xbm256h; *chWp = xbm256w;
  } else {
    *chHp = xbmJISh; *chWp = xbmJISw;
  }

  if (isH1) { *chHp <<= 1; *chWp <<= 1; }
#ifdef UNDERLINE
  if (isAnchor) { *Acharp = "u"; *chHp += 2; }
#endif
}

static int GIFCII_switch_H (sp)
     char *sp;
{
  int match = 1;

	if (!isH2 && !strncscmp (sp, "<H2>", 4)) { isH2 = 1; Hchar = "i"; } else
	if (!isH3 && !strncscmp (sp, "<H3>", 4)) { isH3 = 1; Hchar = "j"; } else
	if (!isH4 && !strncscmp (sp, "<H4>", 4)) { isH4 = 1; Hchar = "j"; } else
	if (!isH5 && !strncscmp (sp, "<H5>", 4)) { isH5 = 1; Hchar = "j"; } else
	if (!isH6 && !strncscmp (sp, "<H6>", 4)) { isH6 = 1; Hchar = "j"; } else
	if (isH1 && !strncscmp (sp, "</H1>", 5)) { isH1 = 0; Hchar = "k"; } else
	if (isH2 && !strncscmp (sp, "</H2>", 5)) { isH2 = 0; Hchar = "k"; } else
	if (isH3 && !strncscmp (sp, "</H3>", 5)) { isH3 = 0; Hchar = "k"; } else
	if (isH4 && !strncscmp (sp, "</H4>", 5)) { isH4 = 0; Hchar = "k"; } else
	if (isH5 && !strncscmp (sp, "</H5>", 5)) { isH5 = 0; Hchar = "k"; } else
	if (isH6 && !strncscmp (sp, "</H6>", 5)) { isH6 = 0; Hchar = "k"; } else
	  match = 0;
	return match;
}
static int
getColor(colorp, sp)
     int *colorp;
     char *sp;
{
  int i=6, j, color=0;

  while (sp[i]==' ' || sp[i]=='\t') { i++; }
  if (sp[i]=='\"') { i++; }
  if (sp[i]=='#') { i++; }

  for (j=i; j<i+6 ; j++) {
    if (sp[j]==0 || sp[j]==' ' || sp[j]=='\"' || sp[j]=='\n')
      break;

    color *= 0x10;

    if (sp[j]>='0' && sp[j]<='9')
      color += sp[j] - '0';
    else if (sp[j]>='A' && sp[j]<='F')
      color += sp[j] - 'A' + 10;
    else if (sp[j]>='a' && sp[j]<='f')
      color += sp[j] - 'a' + 10;
  }

  *colorp = color;
  return j-1;
}
static int GIFCII_switch_Color (sp, isMozilla)
    char *sp;
    int isMozilla;
{
  int i;
	if (isMozilla && !strncscmp(sp, "<BODY", 5))
	  {
	    int isText=0, isLink=0, j;
	    for (i = 0; sp[i] != '>' && sp[i]; i++)
	      {
		  if (sp[i]==' ' || sp[i]=='\"' || sp[i]=='\n')
		    {
		      if (!isText && !strncscmp(sp+i+1, "TEXT=", 5))
			{
			  isText = 1;
			  i += getColor(&txColor, sp+i);
		        }
		      if (!isLink && !strncscmp(sp+i+1, "LINK=", 5))
			{
			  isLink = 1;
			  i += getColor(&lkColor, sp+i);
		        }
		    }
	      }
	    return 1;
	  }
	else
	    return 0;
}

static unsigned char *
GIFCII_put256CII (dp, sp, chH, chW, ubase, charset, Achar, isMozilla, cs256)
     unsigned char *dp, *sp, *ubase, *charset, *Achar;
{
  unsigned char t256c;
  int w;

  sprintf (dp, "<IMG SRC=\"%s%s/%06x%s%s", ubase, charset, fgColor, Hchar, Achar);
  dp += strlen (dp);

  for (w=0; w<GIFWIDTH && (sp[0] & 0x80); w++) {
    t256c = (isKOI) ? koi8tocyr (sp[0]) : sp[0];
    sprintf (dp, "%02x%02x", cs256, t256c);
    sp++;
    dp += 4;
  }
  if (isMozilla)
    sprintf (dp, "\" WIDTH=%d HEIGHT=%d BORDER=0>", chW*w, chH);
  else
    sprintf (dp, "\">");
  return sp;
}

static unsigned char *
GIFCII_putJISCII (dp, sp, chH, chW, ubase, charset, Achar, isMozilla)
  unsigned char *dp,*sp,*ubase,*charset,*Achar;
{
  int w;

  sprintf (dp, "<IMG SRC=\"%s%s/%06x%s%s", ubase, charset, fgColor, Hchar, Achar);
  dp += strlen(dp);
  for (w=0; w<GIFWIDTH && (sp[0] & 0x80) && (sp[1] & 0x80); w++) {
    sprintf (dp, "%x%x", sp[0], sp[1]);
    sp += 2;
    dp += 4;
  }
  if (isMozilla)
    sprintf (dp, "\" WIDTH=%d HEIGHT=%d BORDER=0>", chW*w, chH);
  else
    sprintf (dp, "\">");
  return sp;
}


/*----
 *	CII/GIF font server
 */
static void
expand_H1 (srcb, dstb, width)
     char *srcb, *dstb;
     int  width;
{
  int expb, expb0, dmask, smask, i, j;

  expb0 = 0;

  for (i=0; i<width; i++) {
    expb = expb0;
    dmask = 7;
    smask = 1;
    for (j=0; j<8; j++) {
      expb |= (srcb[i] & smask) ? dmask : 0;
      smask <<= 1;
      dmask <<= 2;
    }
    dstb[i*2+0] = (char)expb;
    dstb[i*2+1] = (char)(expb>>8);
    expb0 = expb>>16;
  }
}

static int
getCII_H1 (picbuf, gifbuf, color, chN, chW, chH, isU)
     char *picbuf, *gifbuf;
     int color, chN, chW, chH, isU;
{
  char picbuf2[4*34*GIFWIDTH];
  int i, j, w;

  w = (chW > 8) ? chN*2 : chN;

  for (i=0; i<chH; i++) {
    expand_H1(picbuf + i*w, picbuf2 + i*2 * w*2, w);
    memcpy(picbuf2 + (i*2+1) * w*2, picbuf2 + i*2 * w*2, w*2);
    if (i>0) {
      for (j=0; j<w*2; j++) {
	picbuf2[i*2 * w*2 + j] |= picbuf2[(i*2-1) * w*2 + j];
      }
    }
  }

  chH *= 2;
  if (isU) {
    memset(picbuf2 + w*2*(chH*2+0), 0x00, w*2);
    memset(picbuf2 + w*2*(chH*2+1), 0xff, w*2);
    chH += 2;
  }

  return PIC_to_GIF(picbuf2, gifbuf, chN*2, chW, chH, color);
}

extern char *xbmsrc[];
extern int xbmind[];

static int
getCII (picbuf, gifbuf, color, chN, chW, chH, isU)
     char *picbuf, *gifbuf;
     int color, chN, chW, chH, isU;
{
  if (isU) {
    int w = (chW > 8) ? chN*2 : chN;
    memset(picbuf + w*(chH+0), 0x00, w);
    memset(picbuf + w*(chH+1), 0xff, w);
    chH += 2;
  }
  return PIC_to_GIF(picbuf, gifbuf, chN, chW, chH, color);
}

static int
getCII_BOLD (picbuf, gifbuf, color, chN, chW, chH, isU)
     char *picbuf, *gifbuf;
     int color, chN, chW, chH, isU;
{
  int i, j, bit0, bit7, w;
  unsigned char *pb;

  pb = (unsigned char *)picbuf;
  w = (chW > 8) ? chN*2 : chN;

  for (i=0; i<chH; i++) {
    bit0 = 0;
    for (j=0; j<w; j++) {
      bit7 = *pb & 0x80;
      *pb |= (*pb<<1) | bit0;
      bit0 = bit7>>7;
      pb++;
    }
  }
  if (isU) {
    memset(picbuf + w*(chH+0), 0x00, w);
    memset(picbuf + w*(chH+1), 0xff, w);
    chH += 2;
  }
  return PIC_to_GIF(picbuf, gifbuf, chN, chW, chH, color);
}

CII_getGIF (name, gifbuf)
    char *name, *gifbuf;
{
  char charset[32], codebuf[GIFWIDTH*4+20], *code, *curgif[GIFWIDTH], picbuf[GIFWIDTH*36];
  int color, isU, Hsize, do256, chN, chW, chH, i, j;

  code = codebuf;
  sscanf (name, "%[^/]/%6x%s", charset, &color, code);

  Hsize = *code++;
  if (Hsize < 'h' || Hsize > 'k') { return 0; }

  if (*code == 'u') {
    isU = 1; code++;
  } else {
    isU = 0;
  }

  do256 = to256c(charset);
  for (chN=0; *code; chN++, code+=4) {
    int cindr, cindc, kanind, c;

    if (chN == GIFWIDTH) { return 0; }
    sscanf(code, "%4x", &c);
    if (do256) {
      cindr = c / 256;
      cindc = c % 256;
      if (cindr > numof256c || xbmind_256[cindr][cindc] == -1) { return 0; }
      curgif[chN] = xbmsrc_256[cindr][xbmind_256[cindr][cindc]];
    } else {
      if (c < 0xa1a1) { return 0; }
      kanind = (c / 256 - 161) * 94 + c % 256 - 161;
      if (xbmind[kanind] == -1) { return 0; }
      curgif[chN] = xbmsrc[xbmind[kanind]];
    }
  }

  if (do256) {
    chW = xbm256w; chH = xbm256h;
  } else {
    chW = xbmJISw; chH = xbmJISh;
  }

  for (i=0; i<chN; i++) {
    for (j=0; j<chH; j++) {
      if (do256) {
	picbuf[chN*j+i] = curgif[i][j];
      } else {
	picbuf[(j*chN+i)*2+0] = curgif[i][j*2+0];
	picbuf[(j*chN+i)*2+1] = curgif[i][j*2+1];
      }
    }
  }

  switch (Hsize) {
  case 'h':
    return getCII_H1 (picbuf, gifbuf, color, chN, chW, chH, isU);
  case 'i':
    return getCII_BOLD (picbuf, gifbuf, color, chN, chW, chH, isU);
  case 'j':
    return getCII_BOLD (picbuf, gifbuf, color, chN, chW, chH, isU);
  case 'k':
    return getCII (picbuf, gifbuf, color, chN, chW, chH, isU);
  }
}

CII_putHTTP_GIF (tc, vno, gkan)
     FILE *tc;
     char *gkan;
{
  int size;
  int leng;
  char gifbuf[3000];

  if ((size = CII_getGIF (gkan, gifbuf)) == 0)
    return 0;

  leng = HTTP_putHeader (tc, vno, "image/gif", size);
  leng += fwrite (gifbuf, 1, size, tc);
  return leng;
}
